<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for JP_GenericCatalogueItem StructType
 * @subpackage Structs
 */
class JP_GenericCatalogueItem extends AbstractStructBase
{
    /**
     * The ItemContentList
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfJP_GenericCatalogueItemContent
     */
    public $ItemContentList;
    /**
     * The Code
     * @var string
     */
    public $Code;
    /**
     * Constructor method for JP_GenericCatalogueItem
     * @uses JP_GenericCatalogueItem::setItemContentList()
     * @uses JP_GenericCatalogueItem::setCode()
     * @param \ArrayType\ArrayOfJP_GenericCatalogueItemContent $itemContentList
     * @param string $code
     */
    public function __construct(\ArrayType\ArrayOfJP_GenericCatalogueItemContent $itemContentList = null, $code = null)
    {
        $this
            ->setItemContentList($itemContentList)
            ->setCode($code);
    }
    /**
     * Get ItemContentList value
     * @return \ArrayType\ArrayOfJP_GenericCatalogueItemContent|null
     */
    public function getItemContentList()
    {
        return $this->ItemContentList;
    }
    /**
     * Set ItemContentList value
     * @param \ArrayType\ArrayOfJP_GenericCatalogueItemContent $itemContentList
     * @return \StructType\JP_GenericCatalogueItem
     */
    public function setItemContentList(\ArrayType\ArrayOfJP_GenericCatalogueItemContent $itemContentList = null)
    {
        $this->ItemContentList = $itemContentList;
        return $this;
    }
    /**
     * Get Code value
     * @return string|null
     */
    public function getCode()
    {
        return $this->Code;
    }
    /**
     * Set Code value
     * @param string $code
     * @return \StructType\JP_GenericCatalogueItem
     */
    public function setCode($code = null)
    {
        // validation for constraint: string
        if (!is_null($code) && !is_string($code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($code, true), gettype($code)), __LINE__);
        }
        $this->Code = $code;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\JP_GenericCatalogueItem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
